; Declare constants for the multiboot header.
MBALIGN  equ  1 << 0            ; align loaded modules on page boundaries
MEMINFO  equ  1 << 1            ; provide memory map
FLAGS    equ  MBALIGN | MEMINFO ; this is the Multiboot 'flag' field
MAGIC    equ  0x1BADB002        ; 'magic number' lets bootloader find the header
CHECKSUM equ -(MAGIC + FLAGS)   ; checksum of above, to prove we are multiboot

section .multiboot
align 4
    dd MAGIC
	dd FLAGS
	dd CHECKSUM

section .bss
align 16

stack_bottom:
resb 16384
stack_top:

; _start = entry to kernel
; Since the bootloader will be gone, it doesn't make sense to return from this
section .text

global _start:function (_start.end - _start)
_start:
    ; 32bit protected mode, no int, no paging
    mov esp, stack_top ; Initialize stack

    extern kmain
    call kmain

    cli ; Turn off interrupts in case they are on
.hang:
    hlt ; Totally halt the cpu
    jmp .hang ; If the cpu un-halts for some reason, halt again

.end: